leetcode hot100 买卖股票的最佳时机二

注意,本题是针对股票可以进行多次交易,但是下次买入的时候必须保证上次买入的已经卖出才可以。

动态规划可以解决整个股票买卖系列问题。

dp数组含义:

dpi0表示第i天不持有股票的最大现金

dpi1表示第i天持有股票的最大现金

递归公式:

由于dpi0表示第i天不持有股票,可能是第i-1天就没有股票,则是dpi-10,也可能是第i-1天持有股票,然后第i天把股票卖了,则是dpi-11+pricesi。二者取最大值,即是第i天不持有股票的最大现金。dpi1表示第i天持有股票,则可能是第i-1天就持有股票,dpi-11,也可能是第i-1天没有股票,然后第i天买入的dpi-10-pricesi。二者取最大值即可。

初始化:

dp00表示第0天不持有股票,则为0

dp01表示第0天持有股票,则此时应该是-prices0

遍历顺序:

我们根据递推公式可以发现,是由前一天推出的后一天,所以我们从前往后直接递推即可。

打印dp数组:

注意,这里我们应该打印最后一天不持有股票的值,也就是dpprices.length-10。因为我们是从下标0开始的,所以最后一天应该是prices.length-1,不持有股票肯定比持有股票钱多,因为股票没有卖掉在手里肯定是算钱的。

复制代码
// 动态规划
class Solution 
    // 实现1:二维数组存储
    // 可以将每天持有与否的情况分别用 dp[i][0] 和 dp[i][1] 来进行存储
    // 时间复杂度:O(n),空间复杂度:O(n)
    public int maxProfit(int[] prices) {
        int n = prices.length;
        int[][] dp = new int[n][2];     // 创建二维数组存储状态
        dp[0][0] = 0;                   // 初始状态
        dp[0][1] = -prices[0];
        for (int i = 1; i < n; ++i) {
            dp[i][0] = Math.max(dp[i - 1][0], dp[i - 1][1] + prices[i]);    // 第 i 天,没有股票
            dp[i][1] = Math.max(dp[i - 1][1], dp[i - 1][0] - prices[i]);    // 第 i 天,持有股票
        }
        return dp[n - 1][0];    // 卖出股票收益高于持有股票收益,因此取[0]
    }
}
相关推荐
hetao173383728 分钟前
2026-10-03~04 hetao1733837 的刷题记录
c++·算法
Zootopia6261 小时前
飞行力学知识梳理1|飞行性能与稳定性
人工智能·python·算法·机器学习·无人机·学习方法·信息与通信
longlongzihan1 小时前
从LeetCode 70. 爬楼梯看动态规划:如何精准推导状态转移方程?
c++·算法·leetcode·动态规划
2601_960356382 小时前
2027校招采购岗解析:数学基础如何迁移到需求预测、成本与供应商分析
人工智能·算法
h_a_o777oah3 小时前
【树论】树链剖分:将树形结构转化为线性结构以处理树上路径问题(洛谷 P3384 附C++代码模板)
数据结构·算法·线段树·acm·树链剖分·树论·重链剖分
HEJOO93 小时前
指针的算术运算详解
java·数据结构·算法
Coder-magician3 小时前
《代码随想录》刷题打卡day47:并查集-part01
数据结构·算法·图论
lsc_blog3 小时前
远程和居家办公的经历,技术简历上怎么摆
面试·职场和发展·重构·pdf·求职招聘
垆边人似月.3 小时前
VLAN 资源池(100~200 分档)
数据结构·算法
潼心1412o4 小时前
C++初阶(长期更新)第6讲:类和对象(下)
开发语言·c++·算法